︠9aab707b-b1be-406c-a660-71a1d89fff17i︠
%html
<p>Let's try to make a <a title="Graph theory @ Wikipedia" href="http://en.wikipedia.org/wiki/Graph_theory" target="_blank">graph</a> of the dependencies among <a title="spkgs described in the Sage developers' guide" href="http://www.sagemath.org/doc/developer/producing_spkgs.html" target="_blank">spkgs</a> in <a title="Sage software home page" href="http://www.sagemath.org" target="_blank">Sage</a>!</p>
<p>We first make some imports explicit and note the version of Sage for which we're making this graph:</p>

︡fe042397-cafb-4b7c-b5d3-216b40006df8︡{"html": "<p>Let's try to make a <a title=\"Graph theory @ Wikipedia\" href=\"http://en.wikipedia.org/wiki/Graph_theory\" target=\"_blank\">graph</a> of the dependencies among <a title=\"spkgs described in the Sage developers' guide\" href=\"http://www.sagemath.org/doc/developer/producing_spkgs.html\" target=\"_blank\">spkgs</a> in <a title=\"Sage software home page\" href=\"http://www.sagemath.org\" target=\"_blank\">Sage</a>!</p>\n<p>We first make some imports explicit and note the version of Sage for which we're making this graph:</p>"}︡
︠370ce137-4dc6-40a8-837d-174b3eb6b40a︠
import os, subprocess
from sage.version import version
from sage.misc.misc import SAGE_ROOT
version
︡112eaa77-9cb3-4266-8133-935d82ce63fc︡{"stdout": "'4.1'"}︡
︠845b61bb-840a-473f-b9d0-92a4056c37aci︠
%html
<p>Appropriately enough, the relevant "<span style="font-family: andale mono,times;">Makefile</span>" in this case lives under <span style="font-family: andale mono,times;">spkg</span> directory:</p>

︡678ad4ca-c163-4291-8dd2-72eeca16943e︡{"html": "<p>Appropriately enough, the relevant \"<span style=\"font-family: andale mono,times;\">Makefile</span>\" in this case lives under <span style=\"font-family: andale mono,times;\">spkg</span> directory:</p>"}︡
︠b3292801-14c6-406d-8dad-4e608781d7bf︠
fd = open(os.path.join(SAGE_ROOT, 'spkg/standard/deps'), 'r')
deps = fd.read()
fd.close()
︡f1ab062d-e001-47fb-ab01-0dc3c564cd74︡︡
︠b8e93deb-28b4-461d-9e4a-d5e25a0ab1fci︠
%html
<p>Now we generate a <a title="Official Python tutorial on dictionaries" href="http://docs.python.org/tutorial/datastructures.html#dictionaries" target="_blank">dictionary</a> whose keys are spkgs.&nbsp; The corresponding value for each key is a list of prerequisite spkgs, distilled from the <span style="font-family: andale mono,times;">Makefile</span>.&nbsp; (Note: It may be better to use <a title="Regular expressions in Python HOWTO " href="http://docs.python.org/howto/regex.html">regular expressions</a> instead.)&nbsp; We also prepare a short list of basic dependencies which we can later exclude from the graph.</p>

︡13492378-4359-4c08-9e8b-fe9a5e92de57︡{"html": "<p>Now we generate a <a title=\"Official Python tutorial on dictionaries\" href=\"http://docs.python.org/tutorial/datastructures.html#dictionaries\" target=\"_blank\">dictionary</a> whose keys are spkgs.&nbsp; The corresponding value for each key is a list of prerequisite spkgs, distilled from the <span style=\"font-family: andale mono,times;\">Makefile</span>.&nbsp; (Note: It may be better to use <a title=\"Regular expressions in Python HOWTO \" href=\"http://docs.python.org/howto/regex.html\">regular expressions</a> instead.)&nbsp; We also prepare a short list of basic dependencies which we can later exclude from the graph.</p>"}︡
︠39bfbe70-b585-4a0e-91c0-eacb5fbc747e︠
d = deps.lower().replace('\\\n', '').replace('\t', '').replace('_spkg','')
d = d.replace('$(inst)/', '').replace('$(', '').replace(')', '')
targets = [li for li in d.split('\n') if ':' in li and '#' not in li]
spkg = {}
for t in targets:
    t = t.split(':')
    spkg[t[0]] = t[1].split(None)
del spkg['base']
common = ['base', 'dir', 'prereq', 'sage_bzip2']
︡ac322ed9-329a-489e-9ceb-d2889594fe93︡︡
︠481be629-65c3-4852-91f6-a3eb818fb580i︠
%html
<p>With the <span style="font-family: andale mono,times;">spkg</span> dictionary we construct a <a title="Directed graph @ Wikipedia" href="http://en.wikipedia.org/wiki/Directed_graph" target="_blank">directed graph</a>, which is a graph whose edges can be "arrows."&nbsp; For convenience, we reverse all of the directed edges and delete some vertices.&nbsp; For more on graphs in Sage, please see the <a title="Graph theory in Sage reference manual" href="http://www.sagemath.org/doc/reference/graphs.html" target="_blank">reference manual</a>.&nbsp; Finally, we try to view the graph, er, graphically:</p>

︡9dd93269-c7f9-4fa8-9b24-5f9eed1cdef2︡{"html": "<p>With the <span style=\"font-family: andale mono,times;\">spkg</span> dictionary we construct a <a title=\"Directed graph @ Wikipedia\" href=\"http://en.wikipedia.org/wiki/Directed_graph\" target=\"_blank\">directed graph</a>, which is a graph whose edges can be \"arrows.\"&nbsp; For convenience, we reverse all of the directed edges and delete some vertices.&nbsp; For more on graphs in Sage, please see the <a title=\"Graph theory in Sage reference manual\" href=\"http://www.sagemath.org/doc/reference/graphs.html\" target=\"_blank\">reference manual</a>.&nbsp; Finally, we try to view the graph, er, graphically:</p>"}︡
︠8506f43c-3a50-4bee-9485-d4ad7deee9aa︠
g = DiGraph(spkg).reverse()
g.delete_vertices(common)
g.plot()
︡24b8b2d7-31d7-4891-8ef1-c58a97b3f959︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠2641c0a0-da9c-4400-9bc5-6665cdce972ei︠
%html
<p>That is quite messy, but with some <a title="sage-devel thread" href="http://groups.google.com/group/sage-devel/browse_thread/thread/90974c5f85027e7a" target="_blank">insight</a> from Robert Miller, we can get a <a title="Public Sage worksheet" href="../../pub/674" target="_blank">neater layout</a>.&nbsp; First, we verify that our graph is indeed a <a title="Directed acyclic graph @ Wikipedia" href="http://en.wikipedia.org/wiki/Directed_acyclic_graph" target="_blank">directed <em>acyclic</em> graph</a> (DAG):</p>

︡17dbdb11-9db5-4757-accf-973f66065b46︡{"html": "<p>That is quite messy, but with some <a title=\"sage-devel thread\" href=\"http://groups.google.com/group/sage-devel/browse_thread/thread/90974c5f85027e7a\" target=\"_blank\">insight</a> from Robert Miller, we can get a <a title=\"Public Sage worksheet\" href=\"../../pub/674\" target=\"_blank\">neater layout</a>.&nbsp; First, we verify that our graph is indeed a <a title=\"Directed acyclic graph @ Wikipedia\" href=\"http://en.wikipedia.org/wiki/Directed_acyclic_graph\" target=\"_blank\">directed <em>acyclic</em> graph</a> (DAG):</p>"}︡
︠d0b6a7e3-9842-4eba-b68a-c0d48b30f95c︠
g.is_directed_acyclic()
︡4605ce69-53b6-41f2-947e-a921d52f1e54︡{"stdout": "True"}︡
︠33bb03c5-b973-4df4-9c6b-e5647abcfb85i︠
%html
<p>This means that none of our spkgs is a prerequisite for itself, either directly or indirectly, which is reassuring news.&nbsp; With this information we can construct a <a title="Partially ordered set @ Wikipedia" href="http://en.wikipedia.org/wiki/Poset" target="_blank">partially ordered set</a>, or poset, from our graph and plot it instead:</p>

︡e8d419d8-92b6-40d1-a048-0703fe78d078︡{"html": "<p>This means that none of our spkgs is a prerequisite for itself, either directly or indirectly, which is reassuring news.&nbsp; With this information we can construct a <a title=\"Partially ordered set @ Wikipedia\" href=\"http://en.wikipedia.org/wiki/Poset\" target=\"_blank\">partially ordered set</a>, or poset, from our graph and plot it instead:</p>"}︡
︠04410060-ef1b-4633-bc52-e7d8502a96f2︠
p = Poset(g) 
p.plot(vertex_size=1500, vertex_colors='#ccffcc').show(figsize=35, aspect_ratio=4)
︡f7cc24ff-7cb7-4e51-bb8c-ab259bfb97b5︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠c1d724c0-7b49-42df-9a71-b433151edc79i︠
%html
<p>We can get an another representation if the <a title="Graphviz software home page" href="http://www.graphviz.org" target="_blank">Graphviz</a> package is installed locally:</p>

︡9e29550a-81e2-443d-ab55-bf424d2434ff︡{"html": "<p>We can get an another representation if the <a title=\"Graphviz software home page\" href=\"http://www.graphviz.org\" target=\"_blank\">Graphviz</a> package is installed locally:</p>"}︡
︠ca3d712b-53f5-45a4-8f58-aa80d9983537︠
loc = ''
format = 'png'
gv_base = os.path.join(loc, 'spkg_deps-' + version)
gv_dot = gv_base + '.dot'
g.graphviz_to_file_named(gv_dot)
cmd = 'dot ' + gv_dot + ' -T' + format + ' -o ' + gv_base + '.' + format + ' '
opts = '-Gratio=auto -Gsize=100,10'
ret = subprocess.call(cmd + opts, shell=True)
︡1459a05a-79b1-44f0-b0da-eeef66c844f1︡{"stdout": "/bin/sh: dot: not found"}︡
︠76e18f14-783e-49a2-8c60-c92608ac0407i︠
%html
<p>It's not, apparently, but here's an uploaded image:</p>

︡2191a757-2481-44c6-99fc-59776a347e21︡{"html": "<p>It's not, apparently, but here's an uploaded image:</p>"}︡
︠2423e5ea-c59b-43b9-8ac6-38a5b2861e9c︠
html('<img src="spkg_deps-4.1.png" />')
︡302289c1-0a02-4b13-a8fd-b60e6f436427︡{"html": "<font color='black'><img src=\"spkg_deps-4.1.png\" /></font>"}︡
︠c521cab8-3e22-4f2e-997c-0945a88d2121i︠
%html
<p>This is just a start.&nbsp; Happy graphing!</p>

︡1c0a363f-f97d-470c-8e5d-57312e1753dc︡{"html": "<p>This is just a start.&nbsp; Happy graphing!</p>"}︡
